Attribute VB_Name = "Module1"
Private Type mpoint
    mx As Long
    my As Long
End Type

Global Endloop As Boolean
Private mousepos As mpoint

Declare Function SelectPalette Lib "gdi32" (ByVal hdc As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Declare Function RealizePalette Lib "gdi32" (ByVal hdc As Long) As Long
Declare Sub GetCursorPos Lib "user32" (ByRef upoint As mpoint)
Declare Function GetAsyncKeyState Lib "user32" (ByVal uAction As Long) As Long


' Our starting point.
' This sets up the control, and then loops until it
' is done

Sub Main()
    ' Setup stuff
    SetupControl
    
    'Show Form
    mainform.Show
    
    ' This is a function that continues to run
    ' until the program quits.  It pays attention
    ' to the form controls and does what it is told
    DoFrames
End Sub

Private Sub SetupControl()
    ' do setup
    result = SelectPalette(mainform.hdc, mainform.RenderAX1.GetPalette, 0)
    result = RealizePalette(mainform.hdc)
End Sub

Private Sub DoFrames()
    ' it might seem easier to get the mouse buttons and movements
    ' through the mousedown and mousemove events, but that's not
    ' really the case. The RenderAX control doesn't handle mouse
    ' events, and Visual basic will only call mousedown and mousemove
    ' if the button is pressed outside the control. Hence, this
    ' roundabout way.
    
    Do While True
      result = SelectPalette(mainform.hdc, mainform.RenderAX1.GetPalette, 0)
      result = RealizePalette(mainform.hdc)
      spin = 0
      mover = 0
      ' get the coordinates of our window on the screen, for use when
      ' determining the hit.
      x = (mainform.Left + mainform!RenderAX1.Left) / Screen.TwipsPerPixelX
      y = (mainform.Top + mainform!RenderAX1.Top) / Screen.TwipsPerPixelY
      w = mainform!RenderAX1.Width / Screen.TwipsPerPixelX
      h = mainform!RenderAX1.Height / Screen.TwipsPerPixelY
      cx = w / 2
      cy = h / 2
      ' Check to see if the mouse button is down
      If GetAsyncKeyState(1) <> 0 Then
         ' Get coordinates, and spin if the mouse is on either
         ' side of the window.
         Call GetCursorPos(mousepos)
         py = mousepos.my - y
         px = mousepos.mx - x
         If px > 0 And px < w And py > 0 And py < h Then
            mainform!RenderAX1.SpinActor 0, (px - cx) / 16
            mainform!RenderAX1.MoveActor 0, 0 - ((py - cy) / 8)
         End If
      End If
    
      If GetAsyncKeyState(37) <> 0 Then
         ' spin to the left
         spin = -1
      End If
      If GetAsyncKeyState(39) <> 0 Then
         ' spin to the right
         spin = 1
      End If
    
      If GetAsyncKeyState(40) <> 0 Then
         ' move forward
         mover = -1
      End If
      If GetAsyncKeyState(38) <> 0 Then
         ' move backward
         mover = 1
      End If
    
      If spin = 0 Then
        If spinning < 0 Then spinning = spinning + 1
        If spinning > 0 Then spinning = spinning - 1
      Else
        spinning = spinning + spin
      End If
    
      If mover = 0 Then
        If moving < 0 Then moving = moving + 1
        If moving > 0 Then moving = moving - 1
      Else
        moving = moving + mover
      End If

      If spinning < -10 Then spinning = -10
      If spinning > 10 Then spinning = 10
      If spinning <> 0 Then
        mainform!RenderAX1.SpinActor 0, spinning
      End If
    
      If moving < -16 Then moving = -16
      If moving > 16 Then moving = 16
      If moving <> 0 Then
         mainform!RenderAX1.MoveActor 0, moving
      End If
    
      mainform!RenderAX1.CheckActor 0
      DoEvents
      If mainform!Check1.Value = 1 Then
        mainform!RenderAX1.Render 2, mainform!VScroll1.Value
      Else
        mainform!RenderAX1.Render 0, mainform!VScroll1.Value
      End If
      DoEvents
      If Endloop = True Then
        Exit Do
      End If
    Loop
   
End Sub
