Attribute VB_Name = "Module1"
Private Type mpoint
    mx As Long
    my As Long
End Type

Global Endloop As Boolean
Private mousepos As mpoint
Private dist As Single, ourx As Single, oury As Single
Private hisx As Single, hisy As Single, dx As Single, dy As Single
Private starttime As Long, endtime As Long, mills As Long, ticks As Long, tickmod As Long, errorterm As Long, robomove As Long
Declare Function SelectPalette Lib "gdi32" (ByVal hdc As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Declare Function RealizePalette Lib "gdi32" (ByVal hdc As Long) As Long
Declare Sub GetCursorPos Lib "user32" (ByRef upoint As mpoint)
Declare Function GetAsyncKeyState Lib "user32" (ByVal uAction As Long) As Long

' Our starting point.
' This sets up the control, and then loops until it
' is done

Sub Main()
    ' Setup stuff
    ticks = 0
    SetupControl
    
    'Show Form
    mainform.Show
    
    ' This is a function that continues to run
    ' until the program quits.  It pays attention
    ' to the form controls and does what it is told
    DoFrames
End Sub

Private Sub SetupControl()
    ' do setup
    mainform!RenderAX1.FlatSet = App.Path + "\default.flt"
    mainform!RenderAX1.BitmapSet = App.Path + "\default.bst"
    mainform!RenderAX1.ActorDefs = App.Path + "\default.typ"
    mainform!RenderAX1.TextureSet = App.Path + "\default.tdf"
    mainform!RenderAX1.Level = App.Path + "\default.4dx"
    result = SelectPalette(mainform.hdc, mainform.RenderAX1.GetPalette, 0)
    result = RealizePalette(mainform.hdc)
End Sub
' Move the robot toward us
Private Sub MoveRobot()
    ' Check the distance between us and the robot.
    ' If the robot is within 768 units, we will move
    ' him toward us, at our angle.
    GetActorPos 0, ourx, oury
    GetActorPos 1, hisx, hisy
    
    ' determine the delta between him and us
    dx = ourx - hisx
    dy = oury - hisy
    
    ' Use 2000 year old geometry to find out how far he is
    dist = Sqr((dx * dx) + (dy * dy))
    
    ' if he's to close or too far, we won't move him, nor update
    ' his data.
    If dist < 768 And dist > 128 Then
       RetrieveActor 1
       ' face the robot toward us
       CurrActor.adjust = -16
       CurrActor.angle = dx_getangle(dx, dy)
       ' update his frame, if needed.
       robomove = robomove + ticks
       If robomove > 8 Then
          robomove = robomove - 8
          CurrActor.currframe = CurrActor.currframe + 1
          If CurrActor.currframe > 4 Then CurrActor.currframe = 0
          RefreshActor 1
          ' move him toward us.
          mainform!RenderAX1.MoveActor 1, 16
       Else
          RefreshActor 1
       End If
       ' might queue a sound, if his frame hits 0.
    End If
    mainform!RenderAX1.CheckActor 1
End Sub

Private Sub DoFrames()
    ' it might seem easier to get the mouse buttons and movements
    ' through the mousedown and mousemove events, but that's not
    ' really the case. The RenderAX control doesn't handle mouse
    ' events, and Visual basic will only call mousedown and mousemove
    ' if the button is pressed outside the control. Hence, this
    ' roundabout way.
    endtime = dx_gettime
    
    Do While True
      result = SelectPalette(mainform.hdc, mainform.RenderAX1.GetPalette, 0)
      result = RealizePalette(mainform.hdc)
      If mainform!Check1.Value = 1 Then
        mainform!RenderAX1.Render 2, mainform!VScroll1.Value
      Else
        mainform!RenderAX1.Render 0, mainform!VScroll1.Value
      End If
      starttime = endtime
      endtime = dx_gettime
      mills = dx_gettimediff(endtime, starttime)
      ticks = mills \ 18
      tickmod = mills Mod 18
      errorterm = errorterm + tickmod
      If errorterm >= 18 Then
         errorterm = errorterm Mod 18
         ticks = ticks + (errorterm \ 18)
      End If
            
      DoEvents
      If Endloop = True Then
        Exit Do
      End If
      spin = 0
      mover = 0
      ' get the coordinates of our window on the screen, for use when
      ' determining the hit.
      x = (mainform.Left + mainform!RenderAX1.Left) / Screen.TwipsPerPixelX
      y = (mainform.Top + mainform!RenderAX1.Top) / Screen.TwipsPerPixelY
      w = mainform!RenderAX1.Width / Screen.TwipsPerPixelX
      h = mainform!RenderAX1.Height / Screen.TwipsPerPixelY
      cx = w / 2
      cy = h / 2
      ' Check to see if the mouse button is down
      If GetAsyncKeyState(1) <> 0 Then
         ' Get coordinates, and spin if the mouse is on either
         ' side of the window.
         Call GetCursorPos(mousepos)
         py = mousepos.my - y
         px = mousepos.mx - x
         If px > 0 And px < w And py > 0 And py < h Then
            mainform!RenderAX1.SpinActor 0, (px - cx) / 16
            mainform!RenderAX1.MoveActor 0, 0 - ((py - cy) / 8)
         End If
      End If
    
      If GetAsyncKeyState(37) <> 0 Then
         ' spin to the left
         spin = -ticks
      End If
      If GetAsyncKeyState(39) <> 0 Then
         ' spin to the right
         spin = ticks
      End If
    
      If GetAsyncKeyState(40) <> 0 Then
         ' move forward
         mover = -ticks
      End If
      If GetAsyncKeyState(38) <> 0 Then
         ' move backward
         mover = ticks
      End If
    
      If spin = 0 Then
        If spinning < 0 Then
           spinning = spinning + ticks
           If spinning > 0 Then spinning = 0
        End If
        If spinning > 0 Then
           spinning = spinning - ticks
           If spinning < 0 Then spinning = 0
        End If
      Else
        spinning = spinning + spin
      End If
    
      If mover = 0 Then
        If moving < 0 Then
            moving = moving + ticks
            If moving > 0 Then moving = 0
        End If
        If moving > 0 Then
            moving = moving - 1
            If moving < 0 Then moving = 0
        End If
      Else
        moving = moving + mover
      End If

      If spinning < -10 Then spinning = -10
      If spinning > 10 Then spinning = 10
      If spinning <> 0 Then
        mainform!RenderAX1.SpinActor 0, spinning
      End If
    
      If moving < -16 Then moving = -16
      If moving > 16 Then moving = 16
      If moving <> 0 Then
         mainform!RenderAX1.MoveActor 0, moving
      End If
    
      mainform!RenderAX1.CheckActor 0
      MoveRobot
      DoEvents
    Loop
   
End Sub
